;==============================================================================
    include \masm32\include\masm32rt.inc
;==============================================================================

BGBRUSH = WHITE_BRUSH       ; must be stock object

;==============================================================================

    .data
      hInst     dd          0
      hWnd      dd          0
      wcx       WNDCLASSEX  <>
      msg       MSG         <>
      className db          "test_class",0
    .code

;==============================================================================

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    SWITCH uMsg

      CASE WM_CREATE

      CASE WM_PAINT

      CASE WM_CLOSE

        invoke DestroyWindow, hWin

      CASE WM_DESTROY

        invoke PostQuitMessage, NULL
        return 0

    .ENDIF

    invoke DefWindowProc, hWin, uMsg, wParam, lParam

    ret

WndProc endp

;==============================================================================
start:
;==============================================================================
    mov   hInst, rv(GetModuleHandle, NULL)
    mov   wcx.cbSize,        sizeof WNDCLASSEX
    mov   wcx.style,         CS_HREDRAW or CS_VREDRAW \
                              or CS_BYTEALIGNWINDOW
    mov   wcx.lpfnWndProc,   OFFSET WndProc
    mov   wcx.cbClsExtra,    NULL
    mov   wcx.cbWndExtra,    NULL
    m2m   wcx.hInstance,     hInst
    mov   wcx.hbrBackground, rv(GetStockObject, BGBRUSH)
    mov   wcx.lpszMenuName,  NULL
    mov   wcx.lpszClassName, OFFSET className
    mov   wcx.hIcon,         rv(LoadIcon, NULL, IDI_APPLICATION)
    mov   wcx.hCursor,       rv(LoadCursor, NULL, IDC_ARROW)
    mov   wcx.hIconSm,       0

    invoke RegisterClassEx, ADDR wcx

    ;--------------------------------
    ; Note the use of CW_USEDEFAULT.
    ;--------------------------------

    invoke CreateWindowEx,  WS_EX_OVERLAPPEDWINDOW,
                            ADDR className,
                            chr$("Test"),
                            WS_OVERLAPPED or WS_SYSMENU,
                            CW_USEDEFAULT,CW_USEDEFAULT,200,150,
                            NULL, NULL,
                            hInst, NULL
    mov   hWnd, eax

    ;------------------------------------------------------------
    ; The ShowWindow nCmdShow parameter is ignored on the first
    ; call if the program that launched the application provided
    ; a STARTUPINFO structure.
    ;------------------------------------------------------------

    invoke ShowWindow, hWnd, SW_SHOWDEFAULT
    invoke UpdateWindow, hWnd
  msgLoop:
    invoke GetMessage, ADDR msg, NULL, 0, 0
    .IF eax != 0
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage, ADDR msg
        jmp   msgLoop
    .ENDIF
    exit msg.wParam
;==============================================================================
end start
